diff --git a/drivers/net/ethernet/qualcomm/rmnet/rmnet_map_data.c b/drivers/net/ethernet/qualcomm/rmnet/rmnet_map_data.c
index 57a9c31..4711150 100644
--- a/drivers/net/ethernet/qualcomm/rmnet/rmnet_map_data.c
+++ b/drivers/net/ethernet/qualcomm/rmnet/rmnet_map_data.c
@@ -163,7 +163,7 @@ rmnet_map_ipv6_dl_csum_trailer(struct sk_buff *skb,
 	if (unlikely(csum_value_final == 0)) {
 		switch (ip6h->nexthdr) {
 		case IPPROTO_UDP:
-			/* RFC 2460 section 8.1
+			/* RFC 8200 section 8.1
 			 * DL6 One's complement rule for UDP checksum 0
 			 */
 			csum_value_final = ~csum_value_final;
diff --git a/drivers/net/usb/smsc95xx.c b/drivers/net/usb/smsc95xx.c
index 355be77..496ed4d 100644
--- a/drivers/net/usb/smsc95xx.c
+++ b/drivers/net/usb/smsc95xx.c
@@ -1269,7 +1269,7 @@ static int smsc95xx_bind(struct usbnet *dev, struct usb_interface *intf)
 	spin_lock_init(&pdata->mac_cr_lock);
 
 	/* LAN95xx devices do not alter the computed checksum of 0 to 0xffff.
-	 * RFC 2460, ipv6 UDP calculated checksum yields a result of zero must
+	 * RFC 8200, ipv6 UDP calculated checksum yields a result of zero must
 	 * be changed to 0xffff. RFC 768, ipv4 UDP computed checksum is zero,
 	 * it is transmitted as all ones. The zero transmitted checksum means
 	 * transmitter generated no checksum. Hence, enable csum offload only
diff --git a/net/ipv6/exthdrs.c b/net/ipv6/exthdrs.c
index 20291c2..fdb4a32 100644
--- a/net/ipv6/exthdrs.c
+++ b/net/ipv6/exthdrs.c
@@ -150,7 +150,7 @@ static bool ip6_parse_tlv(const struct tlvtype_proc *procs,
 			break;
 
 		case IPV6_TLV_PADN:
-			/* RFC 2460 states that the purpose of PadN is
+			/* RFC 8200 states that the purpose of PadN is
 			 * to align the containing header to multiples
 			 * of 8. 7 is therefore the highest valid value.
 			 * See also RFC 4942, Section 2.1.9.5.
@@ -561,7 +561,7 @@ static int ipv6_rthdr_rcv(struct sk_buff *skb)
 
 	/*
 	 *	This is the routing header forwarding algorithm from
-	 *	RFC 2460, page 16.
+	 *	Section 4.4, RFC 8200.
 	 */
 
 	n = hdr->hdrlen >> 1;
diff --git a/net/ipv6/netfilter/nf_conntrack_reasm.c b/net/ipv6/netfilter/nf_conntrack_reasm.c
index 3de0e9b..5fc9a5d 100644
--- a/net/ipv6/netfilter/nf_conntrack_reasm.c
+++ b/net/ipv6/netfilter/nf_conntrack_reasm.c
@@ -228,7 +228,7 @@ static int nf_ct_frag6_queue(struct frag_queue *fq, struct sk_buff *skb,
 		 * Required by the RFC.
 		 */
 		if (end & 0x7) {
-			/* RFC2460 says always send parameter problem in
+			/* RFC8200 says always send parameter problem in
 			 * this case. -DaveM
 			 */
 			pr_debug("end of fragment not rounded to 8 bytes.\n");
diff --git a/net/ipv6/reassembly.c b/net/ipv6/reassembly.c
index 1a832f5..bc0a361 100644
--- a/net/ipv6/reassembly.c
+++ b/net/ipv6/reassembly.c
@@ -158,7 +158,7 @@ static int ip6_frag_queue(struct frag_queue *fq, struct sk_buff *skb,
 		 * Required by the RFC.
 		 */
 		if (end & 0x7) {
-			/* RFC2460 says always send parameter problem in
+			/* RFC8200 says always send parameter problem in
 			 * this case. -DaveM
 			 */
 			*prob_offset = offsetof(struct ipv6hdr, payload_len);
diff --git a/net/ipv6/syncookies.c b/net/ipv6/syncookies.c
index e997141..48e07b2 100644
--- a/net/ipv6/syncookies.c
+++ b/net/ipv6/syncookies.c
@@ -27,7 +27,7 @@
 
 static siphash_key_t syncookie6_secret[2] __read_mostly;
 
-/* RFC 2460, Section 8.3:
+/* RFC 8200, Section 8.3:
  * [ipv6 tcp] MSS must be computed as the maximum packet size minus 60 [..]
  *
  * Due to IPV6_MIN_MTU=1280 the lowest possible MSS is 1220, which allows
diff --git a/net/ipv6/tcp_ipv6.c b/net/ipv6/tcp_ipv6.c
index beaf284..d74537f 100644
--- a/net/ipv6/tcp_ipv6.c
+++ b/net/ipv6/tcp_ipv6.c
@@ -602,7 +602,7 @@ static int tcp_v6_md5_hash_headers(struct tcp_md5sig_pool *hp,
 	struct tcphdr *_th;
 
 	bp = hp->scratch;
-	/* 1. TCP pseudo-header (RFC2460) */
+	/* 1. TCP pseudo-header (RFC8200) */
 	bp->saddr = *saddr;
 	bp->daddr = *daddr;
 	bp->protocol = cpu_to_be32(IPPROTO_TCP);
diff --git a/net/ipv6/udp.c b/net/ipv6/udp.c
index 07fa579..f0e0f2a 100644
--- a/net/ipv6/udp.c
+++ b/net/ipv6/udp.c
@@ -739,7 +739,7 @@ static bool __udp_v6_is_mcast_sock(struct net *net, struct sock *sk,
 
 static void udp6_csum_zero_error(struct sk_buff *skb)
 {
-	/* RFC 2460 section 8.1 says that we SHOULD log
+	/* RFC 8200 section 8.1 says that we SHOULD log
 	 * this error. Well, it is reasonable.
 	 */
 	net_dbg_ratelimited("IPv6: udp checksum is 0 for [%pI6c]:%u->[%pI6c]:%u\n",
diff --git a/net/netfilter/xt_TCPMSS.c b/net/netfilter/xt_TCPMSS.c
index 98efb20..2fd6ffd 100644
--- a/net/netfilter/xt_TCPMSS.c
+++ b/net/netfilter/xt_TCPMSS.c
@@ -167,7 +167,7 @@ tcpmss_mangle_packet(struct sk_buff *skb,
 	/*
 	 * IPv4: RFC 1122 states "If an MSS option is not received at
 	 * connection setup, TCP MUST assume a default send MSS of 536".
-	 * IPv6: RFC 2460 states IPv6 has a minimum MTU of 1280 and a minimum
+	 * IPv6: RFC 8200 states IPv6 has a minimum MTU of 1280 and a minimum
 	 * length IPv6 header of 60, ergo the default MSS value is 1220
 	 * Since no MSS was provided, we must use the default values
 	 */